#pragma once

#include "traversable.h"
#include "vector.h"

namespace brixx
{

class Model;
class IEventTarget;

class Ball : public Traversable<Ball>
{
public:

	static void resetAll(const Model& aModel);
	static void updateAll(const Model& aModel, IEventTarget& aTarget);

	Ball(const Vector2f& aPosition);

	//members
	Vector2f myPosition, mySpeed;

private:

	void reset(const Model& aModel);
	void update(const Model& aModel, IEventTarget& aTarget);
};

}