#pragma once

#include "vector.h"

namespace brixx
{

class State;
struct Style;

class Canvas
{
public:

	Canvas(State& aState, const int aWidth, const int aHeight, const unsigned int aColor);
	~Canvas();
	Gdiplus::Graphics& getGraphics();
	void text(const int aX, const int aY, const WCHAR* aText, const unsigned int aColor, const int aWidth = -1);
	const bool button(const int aX, const int aY, const int aWidth, const WCHAR* aText, const bool anActive = true);
	const bool radio(const bool anActive, const int aX, const int aY, const int aWidth, const WCHAR* aText);
	void fillRect(const Gdiplus::Color& aColor, const int aX, const int aY, const int aWidth, const int aHeight) const;
	void render(Gdiplus::Graphics& aTarget);
	const int buttonHeight() const;
	const bool isDown(const int aKey) const;
	const bool wasPressed(const int aKey) const;
	const bool hasFocus() const;
	const bool cursorInsideGui() const;
	const Vector2i cursorPos() const;

private:

	const bool buttonRect(const Style& aStyle, const int aX, const int aY, const int aWidth, const int aHeight);
	void renderRect(const bool anInside, const bool aDown, const Style& aStyle, const int aX, const int aY, const int aWidth, const int aHeight) const;
	const bool insideRect(const ::POINT& aPoint, const int aX, const int aY, const int aWidth, const int aHeight) const;
	const bool wasPressedInverted(const int aKey) const;

	//members
	State& myState;
	Gdiplus::Bitmap myCanvas;
	Gdiplus::Graphics* myGraphics;
};

}