#include "stdafx.h"
#include "icontroller.h"

#include "model.h"
#include "assets.h"

namespace brixx
{

IController::IController(const Assets& someAssets, const Model& aModel, IEventTarget& aTarget)
:myAssets(someAssets)
,myModel(aModel)
,myTarget(aTarget)
{
}

void IController::drawBrixx(Canvas& aCanvas)
{
	int x, y;

	for(y = 0; y < Model::BRIXX_Y; y++)
	{
		for(x = 0; x < Model::BRIXX_X; x++)
		{
			if(myModel.brick(x, y))
				myAssets.myBrick.draw(aCanvas, ORIGIN.x + x * Model::BRICK_WIDTH, ORIGIN.y + y * Model::BRICK_HEIGHT);
		}
	}
}

const Vector2i IController::ORIGIN(64, 0);

}