#include "stdafx.h"
#include "image.h"

#include "canvas.h"

namespace brixx
{

Image::Image()
:myImage(NULL)
{
}

Image::~Image()
{
	delete myImage;
}

const bool Image::init(const WCHAR* aFile)
{
	return (myImage = new Gdiplus::Image(aFile)) != NULL;
}

void Image::draw(Canvas& aCanvas, const int aX, const int aY) const
{
	//WTF, have to specify the original width else it scales?!?!?
	aCanvas.getGraphics().DrawImage(myImage, aX, aY, myImage->GetWidth(), myImage->GetHeight());
}

const int Image::width() const
{
	return myImage->GetWidth();
}

const int Image::height() const
{
	return myImage->GetHeight();
}

}