#include "stdafx.h"
#include "keystate.h"

namespace brixx
{

KeyState::KeyState()
{
	clear();
}

void KeyState::clear()
{
	myLast = myCurrent = false;
}

void KeyState::sample(const int aKey)
{
	myLast = myCurrent;
	myCurrent = ::GetAsyncKeyState(aKey) != 0;
}

const bool KeyState::isDown() const
{
	return myCurrent;
}

const bool KeyState::wasPressed() const
{
	return myLast && !myCurrent;
}

const bool KeyState::wasPressedInverted() const
{
	return !myLast && myCurrent;
}

}