#include "stdafx.h"
#include "metacontroller.h"

#include "canvas.h"
#include "model.h"

namespace brixx
{

//IDraw
const bool MetaController::draw(Canvas& aCanvas)
{
	int x, y;

	aCanvas.fillRect(0xff1f1f1f, 0, 0, IController::ORIGIN.x, Model::PLAYFIELD_HEIGHT);
	aCanvas.fillRect(0xff1f1f1f, 0, Model::PLAYFIELD_HEIGHT, Model::PLAYFIELD_WIDTH * 64, Model::PADDLE_HEIGHT);

	if(aCanvas.button(x = 0, y = 0, 64, L"quit"))
		return false;
	if(aCanvas.radio(myController == &myPlay, x, y += aCanvas.buttonHeight(), 64, L"play"))
	{
		myTarget.reset();
		myController = &myPlay;
	}
	if(aCanvas.radio(myController == &myEdit, x, y += aCanvas.buttonHeight(), 64, L"edit"))
	{
		myTarget.reset();
		myController = &myEdit;
	}

	return myController->draw(aCanvas);
}

//specific
MetaController::MetaController(const Assets& someAssets, const Model& aModel, IEventTarget& aTarget)
:myPlay(someAssets, aModel, aTarget)
,myEdit(someAssets, aModel, aTarget)
,myController(&myPlay)
,myTarget(aTarget)
{
}

const bool MetaController::playing() const
{
	return myController == &myPlay;
}

}