#include "stdafx.h"
#include "state.h"

namespace brixx
{

State::State(const int aButtonHeight)
:myButtonHeight(aButtonHeight)
,myWindow(0)
,myInsideRect(false)
{
}

void State::update()
{
	unsigned int i;

	for(i = 0; i < NUM_KEYSTATES; i++)
		myKeyStates[i].sample(i);

	myInsideRect = false;
}

const bool State::isDown(const int aKey) const
{
	if(aKey >= 0 && aKey < NUM_KEYSTATES)
		return myKeyStates[aKey].isDown();
	else
		return false;
}

const bool State::wasPressed(const int aKey) const
{
	if(aKey >= 0 && aKey < NUM_KEYSTATES)
		return myKeyStates[aKey].wasPressed();
	else
		return false;
}

const bool State::wasPressedInverted(const int aKey) const
{
	if(aKey >= 0 && aKey < NUM_KEYSTATES)
		return myKeyStates[aKey].wasPressedInverted();
	else
		return false;
}

const ::POINT State::cursorPos() const
{
	::POINT cp;

	::GetCursorPos(&cp);
	::ScreenToClient(myWindow, &cp);

	return cp;
}

const bool State::hasFocus() const
{
	return ::GetFocus() == myWindow;
}

}