#pragma once

#include "keystate.h"

namespace brixx
{

class State
{
public:

	State(const int aButtonHeight);
	void update();
	const bool isDown(const int aKey) const;
	const bool wasPressed(const int aKey) const;
	const bool wasPressedInverted(const int aKey) const;
	const ::POINT cursorPos() const;
	const bool hasFocus() const;

	//members
	const int myButtonHeight;
	::HWND myWindow;
	bool myInsideRect;

private:

	enum
	{
		NUM_KEYSTATES = 256,
	};

	//members
	KeyState myKeyStates[NUM_KEYSTATES];
};

}