#pragma once

namespace brixx
{

class Timer
{
public:

	Timer(const unsigned int aMillisecondsPerTick)
	:myMillisecondsPerTick(aMillisecondsPerTick)
	,myElapsed(0)
	,myNow(::timeGetTime())
	{
	}

	void update()
	{
		if(ready())
			myElapsed -= myMillisecondsPerTick;
		const unsigned int NEW_NOW(::timeGetTime());
		myElapsed += NEW_NOW - myNow;
		myNow = NEW_NOW;
	}

	const bool ready()
	{
		return myElapsed > myMillisecondsPerTick;
	}

private:

	const unsigned int myMillisecondsPerTick;
	unsigned int myElapsed, myNow;
};

}