#pragma once

#include "state.h"

namespace brixx
{

class IDraw;

class View
{
public:

	View(const unsigned int aBackgroundColor, const int aButtonHeight);
	void init(::HINSTANCE hInstance,
				::INT iCmdShow,
				const WCHAR* anIconFile,
				const int aWidth,
				const int aHeight,
				const ::WCHAR* aTitle,
				const int aBrush,
				const ::DWORD aWindowStyle,
				const bool aChroma,
				const ::COLORREF aChromaColor);
	void cleanup();
	const bool draw(IDraw& aDraw);
	const bool isIconic() const;

private:

	void doPaint(const ::HWND aWindow);

	//members
	const unsigned int myBackgroundColor;
	State myState;

	//for render call
	friend ::LRESULT CALLBACK wndProc(::HWND hWnd, ::UINT message, ::WPARAM wParam, ::LPARAM lParam);
};

}